{{- if .Values.edge.enabled }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "ovenmediaengine.fullname" . }}-edge
  labels:
    type: "edge"
    {{- include "ovenmediaengine.labels" . | nindent 4 }}
spec:
  {{- if not .Values.edge.autoscaling.enabled }}
  replicas: {{ .Values.edge.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      type: "edge"
      {{- include "ovenmediaengine.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        type: "edge"
        {{- include "ovenmediaengine.labels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      containers:
        - name: {{ .Chart.Name }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          env:
            - name: "OME_API_ACCESS_TOKEN"
              valueFrom:
                secretKeyRef:
                  name: {{ include "ovenmediaengine.fullname" . }}-api-token
                  key: "token"
          ports:
            - name: http-stream
              containerPort: 3333
              protocol: TCP

            - name: http-api
              containerPort: 8081
              protocol: TCP

          resources:
            {{- toYaml .Values.edge.resources | nindent 12 }}
          volumeMounts:
            - name: "config"
              mountPath: "/opt/ovenmediaengine/bin/origin_conf/Server.xml"
              subPath: "Server.xml"
              readOnly: true
        {{- if .Values.exporter.enabled }}
        - name: {{ .Chart.Name }}-exporter
          image: "{{ .Values.exporter.image.repository }}:{{ .Values.exporter.image.tag }}"
          imagePullPolicy: {{ .Values.exporter.image.pullPolicy }}
          ports:
            - name: http-exporter
              containerPort: 9100
              protocol: TCP
          env:
            - name: "OVEN_E_LISTEN"
              value: ":9100"
            - name: "OVEN_E_API__URL"
              value: "http://localhost:8081"
            - name: "OVEN_E_API__TOKEN"
              valueFrom:
                secretKeyRef:
                  name: {{ include "ovenmediaengine.fullname" . }}-api-token
                  key: "token"
          resources:
              {{- toYaml .Values.exporter.resources | nindent 12 }}
        {{- end }}
      volumes:
        - name: "config"
          secret:
            secretName: {{ include "ovenmediaengine.fullname" . }}-config-file
            optional: false
            items:
              - key: "edge.xml"
                path: "Server.xml"
      {{- with .Values.edge.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.edge.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.edge.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
{{- end }}